#pragma once

template <typename T>
class RectangleT
{
public:
    T x1=0;
    T y1=0;
    T x2=0;
    T y2=0;

    RectangleT()
    {
        Set(0,0,0,0);
    }

    RectangleT(T x1,T y1,T x2, T y2)
    {
        Set(x1,y1,x2,y2);
    }

    void Set(T x1,T y1,T x2, T y2)
    {
        this->x1=x1;
        this->y1=y1;
        this->x2=x2;
        this->y2=y2;
    }

    bool Collide(RectangleT other)
    {
        return !(other.x1 > x2 || other.x2 < x1 || other.y1 > y2 || other.y2 < y1);
    }

};
